<template>
  <div id="simon">
    <div id="header">            
      <p>LEVEL {{ levelNumber }}</p>
      <startBtnComponent v-on:click="startGame" :disabled="gameIsRunning" />
    </div>

    <div v-show="gameIsRunning" id="bordOfGame">
      <btnComponent v-for="color in colors"  v-bind:key="color.id" v-bind:color="color" v-on:click="playerChoosedColor(color)"/>
    </div>
  </div>
</template>

<script>
  import BtnComponent from '../components/SimonBtn';
  import StartBtnComponent from '../components/StartBtn';

  export default {
      name: "Simon",
      components:{
        StartBtnComponent,
        BtnComponent
      },
      data: () => {
        return {
          levelNumber: 0,
          gameIsRunning: false,
          playerPattern:[],
          colorPattern:[],
          colors: [
              {
                  id: "one",
                  color: "green",
                  isSelected: false,
                  isSelectedColor: "#86CB76",
                  sound: "./sounds/green.ogg"
              },
              {
                  id: "two",
                  color: "red",
                  isSelected: false,
                  isSelectedColor: "#DA5652",
                  sound: "./sounds/red.ogg"
              },
              {
                  id: "three",
                  color: "yellow",
                  isSelected: false,
                  isSelectedColor: "#DADA60",
                  sound: "./sounds/yellow.ogg"
              },
              {
                  id: "four",
                  color: "blue",
                  isSelected: false,
                  isSelectedColor: "#6666DE",
                  sound: "./sounds/blue.ogg"
              }
          ],
        }
      },
      methods: {
          //choose color randomly(0,max);
          getRandomInt: function(max)
          {
              return Math.floor(Math.random() * Math.floor(max));
          },
          
          //start a new game
          startGame: function () {
              this.gameIsRunning = true;
              this.levelNumber = this.levelNumber + 1;
              this.chooseAColorRandomly();
          },

          // the color combo is correct
          isCorrectChoice: function() {
              for(var i=0; i<this.colorPattern.length; i++){
                  if(this.colorPattern[i].id !== this.playerPattern[i].id){
                      this.colorPattern = [];
                      this.resetPlayerPattern();
                      return false;
                  }
              }
              
              this.resetPlayerPattern();
              return true;
          },

          //player choose one color
          playerChoosedColor: function(colorChoosed){
              let currentColor = this.colors.indexOf(colorChoosed);
              this.playerPattern.push(this.colors[currentColor]);

              if(this.colorPattern.length === this.playerPattern.length){
                  if(this.isCorrectChoice()){
                      this.levelNumber = this.levelNumber + 1;
                      this.chooseAColorRandomly();
                  }
                  else{
                      this.stopGame();
                  }
              }
          },

          //reset array of player choice
          resetPlayerPattern: function(){
              this.playerPattern = [];
          },
          
          //stop a game when the player loose
          stopGame: function(){
              alert("C'est loose gg!");
              this.levelNumber = 0;
              this.gameIsRunning = false; 
          },

          //highlight div when choosed
          highlightDiv: function(color, i){
              let indiceBoucle = i+1;
              setTimeout(() => {
                  this.playMusicByColor(color);
                  color.isSelected= true;
              }, 400*indiceBoucle);

              setTimeout(() => {
                  color.isSelected= false;
              }, 400*indiceBoucle+300);
          },

          //play music by color
          playMusicByColor: function(currentColor) {
              let pathFileMusic = currentColor.sound;
              let audio = new Audio(pathFileMusic);
              audio.play();
          },

          //choose a color randomly
          chooseAColorRandomly: function(){
              let numberColor = this.getRandomInt(4);
              let currentColor = this.colors[numberColor];
              this.colorPattern.push(currentColor);

              for(var i=0; i<this.colorPattern.length; i++){
                  //in simonBtnComponent.js
                  // highlightDiv(this.colorPattern[i], i)
                  this.highlightDiv(this.colorPattern[i], i)
              }
          },
      }
  };
</script>

<style>
  #one{
      border: solid grey;
    background-color: #3abe1d;
    border-radius:100% 0 0 0;
  }

  #two{
      border: solid grey;
    background-color:#d81913;
    border-radius:0 100% 0 0 ;
  }

  #three{
      border: solid grey;
    background-color:#f7f706f6;
    border-radius:0 0 0 100%;
  }

  #four{
      border: solid grey;
    background-color:#1515e0;
    border-radius:0 0 100% 0;
  }

  #header{
      width: 4%;
      margin: auto;
  }

  #bordOfGame{
      display: flex;
      flex-wrap: wrap;
      padding-top:2%;
      width: 20%;
      margin:auto;
  }

  #bordOfGame div{
      flex:0 45%;
      height: 200px;
  }

  #bordOfGame div:active{
      background-color: #666;
      opacity: 0.33;
      transform: translateY(2px);
  }
</style>
